SystemOrganization addCategory: #FuelPresentations!

TestCase subclass: #FuelESUG2011
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPresentations'!

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MarianoMartinezPeck 8/17/2011 12:22'!
debuggerWorkspaceText 
	^ 	
	'
	| a |
	a := ''Hello ESUG. The answer is....''.
	a := a , ''42!!!!''.
	Transcript show: a.
	'! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MartinDias 11/1/2011 12:20'!
materializeAndOpenDebugger
	| newDebugger |
	newDebugger := FLMaterializer materializeFromFileNamed: 'testDebugger'.
	newDebugger openFullMorphicLabel: 'This is the new debugger!!'.
! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MartinDias 11/1/2011 12:24'!
materializePharoDebug
	| aStream newContext |
	"FIRST EDIT logError:  inContext: "
	newContext := FLMaterializer materializeFromFileNamed: 'PharoDebug.fuel'.
	"(Debugger context: newContext)  openFullMorphicLabel: 'This is the new debugger!!'."
	Debugger openContext: newContext label:  'This is the new debugger!!' contents: nil
! !

!FuelESUG2011 classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 8/17/2011 12:11'!
newWorkspaceWithContents: aString title: aTitle position: position extent: extent
	|ws|
	ws := Workspace new.
	ws acceptContents: aString.
	(ws embeddedInMorphicWindowLabeled: aTitle)
		position: 50@120;
		extent: 800 @ 500;
		openAsIs.
		ws changed: #contents! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MarianoMartinezPeck 8/17/2011 12:11'!
openDebuggerWorkspace
	"self openDebuggerWorkspace"
	self 
		newWorkspaceWithContents: self debuggerWorkspaceText 
		title: 'Code to debug' 
		position: 80@90 
		extent: 800 @ 500
	 ! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MarianoMartinezPeck 8/22/2011 16:45'!
serializeAndMaterializeExample
	| sourceArray loadedArray |

	sourceArray := 
		Array 
			with: 'a string' 
			with: Transcript
			with: [ Transcript show: 'a string' ].

	"Store to the file"
	FLSerializer serialize: sourceArray toFileNamed: 'example.FL'. 

	"Load from the file"
	loadedArray := FLMaterializer materializeFromFileNamed: 'example.FL'. 

	"The arrays are not the same"
	[ sourceArray ~~ loadedArray ] assert.

	"The strings are not the same"
	[ sourceArray first ~~ loadedArray first ] assert.
	[ sourceArray first = loadedArray first ] assert.

	"The global instance Transcript is the same"
	[ sourceArray second == loadedArray second ] assert.

	"Look at Transcript how the loaded block prints a string"
	loadedArray third value.! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MartinDias 11/1/2011 12:22'!
serializeAndMaterializeSomething
	| materializedObject |
	FLSerializer 
		serialize: 'WHATEVER!!!!!!' 
		toFileNamed: 'testSomething'.
	
	materializedObject := FLMaterializer materializeFromFileNamed: 'testSomething'.! !

!FuelESUG2011 classSide methodsFor: 'debugger example' stamp: 'MartinDias 11/1/2011 12:19'!
serializeDebugger

	Smalltalk garbageCollect.
	FLSerializer 
		serialize: (Debugger allInstances first) 
		toFileNamed: 'testDebugger'.
! !

!FuelESUG2011 methodsFor: 'Riak example' stamp: 'MarianoMartinezPeck 8/20/2011 19:56'!
testFuelWithRiak
	| bucket storedObject materializedObject aRectangle client |
	"Before doing this, go to cd /Users/mariano/PhD/riak-0.14.0/bin/ and execute ./riak start "
	client := EpigentRiakClient newForRestConnection: 'http://localhost:8098/riak'.
	aRectangle := Rectangle origin: (4@2) corner: (7@1).
	storedObject := FLSerializer serializeInMemory: aRectangle.
	bucket := client bucketNamed: 'testESUG' .
	bucket atKey: 'test' put: storedObject type: 'application/binary'.
	"Take a browser and go to http://localhost:8098/riak/testESUG/test"
	self halt.
	self assert: (bucket atKey: 'test') = storedObject.
	materializedObject := FLMaterializer materializeFromByteArray: storedObject.
	self assert: materializedObject origin = (4@2).
	self assert: materializedObject corner = (7@1).
! !

!FuelESUG2011 methodsFor: 'Riak example' stamp: 'MarianoMartinezPeck 8/20/2011 19:54'!
testFuelWithSandstoneDB

| commitTime people lookupTime loadTime |
  "  SDFileStore serializer:  SDSmartRefStreamSerializer new."
SDFileStore serializer: SDFuelSerializer new.
SDActiveRecord
   setStore: SDFileStore new;
   warmUpAllClasses.
	"only want to warm up test models, not anything else that might be in this image"
	SDFooObject warmUp.
	SDPersonMock withAllSubclasses do: [ :each | each warmUp ].
	
    people := (1 to: 500) collect: [ :it | SDPersonMock testPerson ].
    commitTime := [ people do: [ :each | each save ] ] timeToRun.
    lookupTime := [ people do: [ :each | SDPersonMock atId: each id ] ] timeToRun.
    loadTime := [
    SDActiveRecord resetStoreForLoad.
    SDPersonMock
        withAllSubclassesDo: [ :each | SDActiveRecord store ensureForClass: each ];
        withAllSubclassesDo: [ :each | each warmUp ].
    SDActiveRecord store ensureForClass: SDFooObject.
    SDFooObject warmUp ] timeToRun.
    Transcript
        show: 'Serialiation time: ', commitTime asString;
        cr;
        show: 'Materialization time: ', loadTime asString;
        cr;
        cr.
    SDPersonMock do: [ :each | [each delete] on: Error do: [] ].
    SDPersonMock coolDown.
    SDFooObject do: [:each | [each delete] on: Error do: [] ].
    SDPersonMock allSubclassesDo: [ :each | each coolDown ].
    Smalltalk garbageCollect
    ! !

TestCase subclass: #FuelPharoConf2011
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPresentations'!

!FuelPharoConf2011 classSide methodsFor: 'debugger demo' stamp: 'MarianoMartinezPeck 5/10/2012 22:48'!
debuggerWorkspaceText 
	^ 	
	'
	| a |
	a := ''Hello Smalltalks2011. The answer is ''.
	a := a , ''42!!''.
	Transcript show: a.
	'! !

!FuelPharoConf2011 classSide methodsFor: 'latest error demo' stamp: 'mada 5/10/2012 20:57'!
materializeAndDebugLatestError
	"FIRST, append the next line at SmalltalkImage>>logError:inContext: 
	FLSerializer serialize: aContext toFileNamed: 'LatestError.fuel'."
	
	| aContext |
	aContext := FLMaterializer materializeFromFileNamed: 'LatestError.fuel'.
	Debugger openContext: aContext label:  'This is the new debugger!!' contents: nil
! !

!FuelPharoConf2011 classSide methodsFor: 'debugger demo' stamp: 'mada 5/10/2012 20:57'!
materializeAndOpenDebugger
	| newDebugger |
	newDebugger := FLMaterializer materializeFromFileNamed: 'debugger.fuel'.
	newDebugger openFullMorphicLabel: 'Materialized debugger ;)'.
! !

!FuelPharoConf2011 classSide methodsFor: 'private' stamp: 'mada 5/10/2012 20:57'!
newWorkspaceWithContents: aString title: aTitle position: position extent: extent
	|ws|
	ws := Workspace new.
	ws acceptContents: aString.
	(ws embeddedInMorphicWindowLabeled: aTitle)
		position: 50@120;
		extent: 800 @ 500;
		openAsIs.
		ws changed: #contents! !

!FuelPharoConf2011 classSide methodsFor: 'debugger demo' stamp: 'mada 5/10/2012 20:57'!
openDebuggerWorkspace
	"self openDebuggerWorkspace"
	self 
		newWorkspaceWithContents: self debuggerWorkspaceText 
		title: 'Code to debug' 
		position: 80@90 
		extent: 800 @ 500
	 ! !

!FuelPharoConf2011 classSide methodsFor: 'simple demos' stamp: 'mada 5/10/2012 20:57'!
serializeAndMaterializeExample
	| sourceArray loadedArray |

	sourceArray := 
		Array 
			with: 'a string' 
			with: Transcript
			with: [ Transcript show: 'a string' ].

	"Store to the file"
	FLSerializer serialize: sourceArray toFileNamed: 'example.FL'. 

	"Load from the file"
	loadedArray := FLMaterializer materializeFromFileNamed: 'example.FL'. 

	"The arrays are not the same"
	[ sourceArray ~~ loadedArray ] assert.

	"The strings are not the same"
	[ sourceArray first ~~ loadedArray first ] assert.
	[ sourceArray first = loadedArray first ] assert.

	"The global instance Transcript is the same"
	[ sourceArray second == loadedArray second ] assert.

	"Look at Transcript how the loaded block prints a string"
	loadedArray third value.! !

!FuelPharoConf2011 classSide methodsFor: 'simple demos' stamp: 'mada 5/10/2012 20:57'!
serializeAndMaterializeSomething
	| materializedObject |
	FLSerializer 
		serialize: 'WHATEVER!!!!!!' 
		toFileNamed: 'testSomething'.
	
	materializedObject := FLMaterializer materializeFromFileNamed: 'testSomething'.! !

!FuelPharoConf2011 classSide methodsFor: 'debugger demo' stamp: 'MarianoMartinezPeck 5/10/2012 23:03'!
serializeDebugger
	| serializer | 
	3 timesRepeat: [Smalltalk garbageCollect].
	Smalltalk garbageCollect.
	serializer := FLSerializer newDefault.
	serializer analyzer useFullMappers.
	serializer 
		serialize: Debugger allInstances first
		toFileNamed: 'debugger.fuel'.
! !

!FuelPharoConf2011 classSide methodsFor: 'latest error demo' stamp: 'mada 5/10/2012 20:57'!
serializeErrorContext: aContext
	"Send this message from SmalltalkImage>>logError:inContext:"

	FLSerializer serialize: aContext toFileNamed: 'LatestError.fuel'.! !

TestCase subclass: #FuelSmalltalks2011
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPresentations'!

!FuelSmalltalks2011 classSide methodsFor: 'debugger demo' stamp: 'MartinDias 11/1/2011 17:14'!
debuggerWorkspaceText 
	^ 	
	'
	| a |
	a := ''Hello Smalltalks2011. The answer is ''
	a := a , ''42!!''.
	Transcript show: a.
	'! !

!FuelSmalltalks2011 classSide methodsFor: 'latest error demo' stamp: 'MartinDias 11/1/2011 17:20'!
materializeAndDebugLatestError
	"FIRST, append the next line at SmalltalkImage>>logError:inContext: 
	FLSerializer serialize: aContext toFileNamed: 'LatestError.fuel'."
	
	| aContext |
	aContext := FLMaterializer materializeFromFileNamed: 'LatestError.fuel'.
	Debugger openContext: aContext label:  'This is the new debugger!!' contents: nil
! !

!FuelSmalltalks2011 classSide methodsFor: 'debugger demo' stamp: 'MartinDias 11/1/2011 17:15'!
materializeAndOpenDebugger
	| newDebugger |
	newDebugger := FLMaterializer materializeFromFileNamed: 'debugger.fuel'.
	newDebugger openFullMorphicLabel: 'Materialized debugger ;)'.
! !

!FuelSmalltalks2011 classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 8/17/2011 12:11'!
newWorkspaceWithContents: aString title: aTitle position: position extent: extent
	|ws|
	ws := Workspace new.
	ws acceptContents: aString.
	(ws embeddedInMorphicWindowLabeled: aTitle)
		position: 50@120;
		extent: 800 @ 500;
		openAsIs.
		ws changed: #contents! !

!FuelSmalltalks2011 classSide methodsFor: 'debugger demo' stamp: 'MarianoMartinezPeck 8/17/2011 12:11'!
openDebuggerWorkspace
	"self openDebuggerWorkspace"
	self 
		newWorkspaceWithContents: self debuggerWorkspaceText 
		title: 'Code to debug' 
		position: 80@90 
		extent: 800 @ 500
	 ! !

!FuelSmalltalks2011 classSide methodsFor: 'simple demos' stamp: 'MarianoMartinezPeck 8/22/2011 16:45'!
serializeAndMaterializeExample
	| sourceArray loadedArray |

	sourceArray := 
		Array 
			with: 'a string' 
			with: Transcript
			with: [ Transcript show: 'a string' ].

	"Store to the file"
	FLSerializer serialize: sourceArray toFileNamed: 'example.FL'. 

	"Load from the file"
	loadedArray := FLMaterializer materializeFromFileNamed: 'example.FL'. 

	"The arrays are not the same"
	[ sourceArray ~~ loadedArray ] assert.

	"The strings are not the same"
	[ sourceArray first ~~ loadedArray first ] assert.
	[ sourceArray first = loadedArray first ] assert.

	"The global instance Transcript is the same"
	[ sourceArray second == loadedArray second ] assert.

	"Look at Transcript how the loaded block prints a string"
	loadedArray third value.! !

!FuelSmalltalks2011 classSide methodsFor: 'simple demos' stamp: 'MartinDias 11/1/2011 12:22'!
serializeAndMaterializeSomething
	| materializedObject |
	FLSerializer 
		serialize: 'WHATEVER!!!!!!' 
		toFileNamed: 'testSomething'.
	
	materializedObject := FLMaterializer materializeFromFileNamed: 'testSomething'.! !

!FuelSmalltalks2011 classSide methodsFor: 'debugger demo' stamp: 'MartinDias 11/1/2011 17:15'!
serializeDebugger

	Smalltalk garbageCollect.
	FLSerializer 
		serialize: Debugger allInstances first
		toFileNamed: 'debugger.fuel'.
! !

!FuelSmalltalks2011 classSide methodsFor: 'latest error demo' stamp: 'MartinDias 11/1/2011 17:21'!
serializeErrorContext: aContext
	"Send this message from SmalltalkImage>>logError:inContext:"

	FLSerializer serialize: aContext toFileNamed: 'LatestError.fuel'.! !
